



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>uWSGI 踩坑记</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">uWSGI 踩坑记</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 21:45:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>一、协议的一致性</h2>
<p>uWSGI 是在 nginx 后面，所以 nginx 转发请求时的协议要和 uWSGI 监听的协议一致。否则就会出现问题，因为是三者之间的通信，排查起来需要想清楚请求传递的次序：<br /><br />
Nginx -&gt; uWSGI -&gt; app</p>
<h3>1.1 uWSGI 异常信息</h3>
<pre class="prettyprint linenums"><code>invalid request block size: 21573 (max 4096)...skip<br />
</code></pre>
<p>如果按照下面的配置就会出现上述的异常：</p>
<pre class="prettyprint linenums"><code># Nginx 配置<br />
location / {<br />
    proxy_pass         http://127.0.0.1:6000;<br />
}<br />
# 搭配 uWSGI 配置<br />
uwsgi --socket :6000 --wsgi-file app.py<br />
</code></pre>
<h3>1.2 Nginx 异常信息</h3>
<pre class="prettyprint linenums"><code>upstream prematurely closed connection while reading response header from upstream, client: 120.xxx.xxx.xxx, server: hellogithub.com, request: &quot;GET / HTTP/1.1&quot;, upstream: &quot;uwsgi://127.0.0.1:6000&quot;, host: &quot;hellogithub.com&quot;<br />
</code></pre>
<p>原因是：nginx 为 uwsgi 协议，uWSGI 为 http 协议，那么请求会到不了 uWSGI。</p>
<h3>1.3 正确配置示例：</h3>
<p><strong>1.通过 uwsgi 协议传递请求</strong></p>
<pre class="prettyprint linenums"><code># Nginx 配置<br />
location / {<br />
    include uwsgi_params;<br />
    uwsgi_pass 127.0.0.1:6000;<br />
}<br />
# 搭配 uWSGI 配置<br />
uwsgi --socket :6000 --wsgi-file app.py<br />
</code></pre>
<p>上述配置的的意思是说 “把每个请求传递到服务器绑定的端口 6000，并且使用 uwsgi 协议通信”。</p>
<p><strong>2.通过 http 协议传递请求（不推荐）</strong></p>
<pre class="prettyprint linenums"><code># Nginx 配置<br />
location / {<br />
    proxy_set_header   Host             $host;<br />
    proxy_set_header   X-Real-IP        $remote_addr;<br />
    proxy_set_header   X-Forwarded-For  $proxy_add_x_forwarded_for;<br />
    proxy_pass         http://127.0.0.1:6000;<br />
}<br />
# 搭配 uWSGI 配置<br />
uwsgi --http :6000 --wsgi-file app.py<br />
</code></pre>
<p>每个请求通过 http 协议传递给 6000端口的服务，但是服务应用想要获得请求的真实 IP 和请求的 http 信息需要在 nginx 中额外配置。</p>
<h2>二、配置参数</h2>
<h3>2.1 指定配置文件启动时</h3>
<p>1.切记配置文件中要有 pidfile 参数</p>
<pre class="prettyprint linenums"><code>pidfile=/tmp/myproject-master.pid<br />
</code></pre>
<p>否则 supervisor 重启 uWSGI 不会关闭进程，而且为不报错。</p>
<p>TODO这样可能会导致另外一个异常，我现在如果使用指定 ini 文件启动就会报这个问题，后面查到原因再来写：</p>
<pre class="prettyprint linenums"><code>robably another instance of uWSGI is running on the same address (:6000).<br />
bind(): Address already in use [core/socket.c line 769]<br />
</code></pre>
<h3>2.2 启动 gevent</h3>
<p><code>uwsgi --gevent 100 --gevent-monkey-patch --http :9090 -M  --processes 4 --wsgi-file wsgi.py</code></p>
<p>增加 <code>--gevent-monkey-patch</code> 参数可以不用修改代码就采用 gevent 方式启动。</p>
<h3>2.3 环境变量</h3>
<p>supervisor 配置的环境变量不会传递给uWSGI启动的服务。举个例子：</p>
<pre class="prettyprint linenums"><code>## supervisor 配置<br />
environmenit=name=hellogithub

## app 代码片段<br />
pro_name = os.getenv('name')<br />
</code></pre>
<p>这时 <code>pro_name</code> 会返回 <code>None</code> 而不是预期的 <code>hellogithub</code>，所以启动 uWSGI 时需要增加环境变量参数：<code>--env name=hellogithub</code>，如此可达到预期。</p>
<h2>三、参考</h2>
<ul><li><a href="http://uwsgi-docs-cn.readthedocs.io/zh_CN/latest/index.html" rel="external nofollow noreferrer">uWSGI 文档</a></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9p2248x.html">android内部培训视频&lowbar;第四节&lpar;1&rpar;&lowbar;异步网络操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zow7vq.html">MVC Razor视图引擎的入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqll33eq.html">jQuery打造智能提示插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8md3lp8.html">CSV格式数据如何导入MySQL？</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zrv6nq.html">在eclipse中使用正则表达式进行搜素</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldow09.html">无废话ExtJs 入门教程三&lbrack;窗体：Window组件&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4951gvvq.html">ob&lowbar;clean（）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kgz739.html">mm&sol;makefile</a>
		</li>
						<li><a href="https://www.batexi.com/a/390g6gm8.html">编译安装GCC 4&period;7&period;2</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zwm6x8.html">Google Kubernetes设计文档之服务篇-转</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdjl0r8.html">Mapper类&sol;Reducer类中的setup方法和cleanup方法以及run方法的介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj2go79.html">js实现对数据库的增删查改</a>
		</li>
						<li><a href="https://www.batexi.com/a/96owy0j9.html">Android安全bug ANDROID-8219321</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j04r7gq.html">STL&mdash;&mdash;空间配置器（构造和析构基本工具）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5kogq.html">武汉科技大学ACM ：1005&colon; 一二三</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k55p09.html">oracle   Database Link</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwn119.html">Linux的学习笔记&lowbar;Day1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzkogl8.html">LNMP下安装Pureftpd开启FTP服务以及修改FTP端口的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r55zo7q.html">&period;Net WebApi开发SharePoint出现System&period;IO&period;FileNotFoundException&colon; 找不到位于的 Web 应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o153lpq.html">Python计算器实操</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8zo0xwvq.html">ios12版本以上键盘唤起后，收回页面不回滚问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ymlmw8.html">03SQLALchemy外键约束</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zkwpg9.html">我的 FPGA 学习历程（12）&mdash;&mdash; 电子钟项目准备</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pv23v8.html">Android 动画 &lpar;1&rpar; 基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz562e8.html">Python网络编程基础pdf</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo0p71q.html">python 多线程 及多线程通信，互斥锁&comma;线程池</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jplev8.html">Mac&lowbar;Sublime Text3（mac）一些插件和快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zlokj9.html">详谈kafka的深入浅出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxk7vlv8.html">microk8s</a>
			</li>
						<li><a href="https://www.batexi.com/a/9502oje8.html">pytorch可视化工具visdom</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
